package com.zipcodewilmington.arrayutility;

import java.lang.reflect.Array;
import java.util.ArrayList;
import java.util.List;

/**
 * Created by leon on 3/6/18.
 */
public class ArrayUtility<T> {


   private T[] inputArray;

    public ArrayUtility(T[] inputArray){
        this.inputArray = inputArray;
    }

    public Integer countDuplicatesInMerge(T[] arrayToMerge, T valueToEvaluate) {

        Integer count = 0;

        for(T t: arrayToMerge){
            if(t.equals(valueToEvaluate)){
                count++;
            }
        }
        for(T t: inputArray){
            if(t.equals(valueToEvaluate)){
                count++;
            }
        }
        return count;
    }


    public Integer getNumberOfOccurrences(T valueToEvaluate) {

        Integer count = 0;
        for(T t: inputArray){
            if(t.equals(valueToEvaluate)){
                count++;
            }
        }
        return count;
    }

    public T getMostCommonFromMerge(T[] arrayToMerge){

        Integer mostCommonCount = 0;
        T mostCommon = arrayToMerge[0];

        for(T t: arrayToMerge){
            if(getNumberOfOccurrences(t) > mostCommonCount){
                mostCommonCount = getNumberOfOccurrences(t);
                mostCommon = t;
            }
        }
        return mostCommon;
    }

    public T[] removeValue(T valueToRemove){

       Integer remove = getNumberOfOccurrences(valueToRemove);

        T[] resultObjectArray = (T[]) Array.newInstance(inputArray.getClass().getComponentType(), inputArray.length - remove);
        int count = 0;

        for(int i = 0; i<inputArray.length; i++){
            if(!inputArray[i].equals(valueToRemove)){
                resultObjectArray[count] = (inputArray[i]);
                count++;
            }
        }
        return resultObjectArray;
    }


}